﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

// neu
using System.Xml.Schema;
using System.Xml.Linq;
using System.Xml;
using System.IO;
using System.Diagnostics;
using System.Runtime.InteropServices; // run
using System.Reflection;
using Microsoft.Win32;

using System.Windows.Threading;  // Timer

namespace XMLVerify
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, IView
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        
        MyTextBox editXML = null;
        MyTextBox editXSD = null;
        MyTextBox editError = null;
        MyFileList2 filelistLeft = null;

        String search = "";
        Boolean ignoreCase = false;

        CModell modell=null;
        int fontsize = 14;

        int validationnumber=0;



        private void Window_Loaded(object sender, RoutedEventArgs e) {
            mnFont14pg.IsChecked = true;

            editXML = new MyTextBox(1, true, true);  // undo   XMLEditor
            editXSD = new MyTextBox(2, true, false);
            editError = new MyTextBox(3, false, false);
    

            //gridcanvas1.Content = canvas;
            canvasLeft.HorizontalAlignment = HorizontalAlignment.Stretch;
            canvasLeft.VerticalAlignment = VerticalAlignment.Stretch;

            canvasRight.HorizontalAlignment = HorizontalAlignment.Stretch;
            canvasRight.VerticalAlignment = VerticalAlignment.Stretch;

            canvasBottom.HorizontalAlignment = HorizontalAlignment.Stretch;
            canvasBottom.VerticalAlignment = VerticalAlignment.Stretch;

            canvasLeft.Children.Add(editXML);
            canvasRight.Children.Add(editXSD);
            canvasBottom.Children.Add(editError);

            //tabControl = new MyTabControl();
            //tabControl.setFontsize(fontsize);

            // canvasTabSheet.Children.Add(tabControl);
            filelistLeft = new MyFileList2();
            filelistLeft.init(this);
            filelistLeft.setFontsize(fontsize);
            canvasTabSheet.Children.Add(filelistLeft);

            modell = CModell.getInstance();
            modell.addObserver(this);

            editXML.Modified = false;
            editXSD.Modified = false;

            SingVar singvar = SingVar.getInstance();
            if (singvar.Setting)  {                
                Application curApp = Application.Current;
                Window mainWindow = curApp.MainWindow;

                int deskWidth = (int)System.Windows.SystemParameters.PrimaryScreenWidth;
                int deskHeight = (int)System.Windows.SystemParameters.PrimaryScreenHeight;

                if (singvar.Top <= deskHeight && singvar.Top + singvar.Height <= deskHeight) {
                    Top = singvar.Top;
                    Height = singvar.Height;
                }
                if (singvar.Left <= deskWidth && singvar.Left + singvar.Width <= deskWidth) {
                    Left = singvar.Left;
                    Width = singvar.Width;
                }
            }

            editXML.WordWrap = singvar.WordWrap;
            editXSD.WordWrap = singvar.WordWrap;
            editError.WordWrap = true;
            mnWordWrap.IsChecked = singvar.WordWrap;

            //editXML.SetTabWidth(singvar.TabLength);
            //editXSD.SetTabWidth(singvar.TabLength);

            String[] args = System.Environment.GetCommandLineArgs();
            for (int i = 1; i < args.Length; i++)  {
                String file = args[i];
                String sExt = Basis.getFilenameExt(file).ToLower();
                if (sExt.Equals("xml") && File.Exists(file))  {
                    modell.FilenameXML = file;
                    // loadFilename1();
                    modell.notifyObservers();
                    break;  // nur der erste gueltige Parameter
                }
            }
            CommandBindings.Add(new CommandBinding(MyCommands.Newfile, NewExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Openfile, OpenExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Savefile, SaveExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SaveAsfile, SaveAsExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Undo, UndoExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Redo, RedoExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Copy, CopyExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Paste, PasteExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Cut, CutExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.Selectall, SelectallExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Search, SearchExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.SearchAgain, SearchAgainExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Editor2Notepad, Editor2NotepadExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Validation, ValidationExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.ValidationXML, ValidationXMLExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.ValidationXSD, ValidationXSDExecuted, CheckCanExecuted));

        
            CommandBindings.Add(new CommandBinding(MyCommands.NewInstanz, NewInstanzExecuted, CheckCanExecuted));
        
            CommandBindings.Add(new CommandBinding(MyCommands.Close, CloseExecuted, CheckCanExecuted));
        
            CommandBindings.Add(new CommandBinding(MyCommands.FormatXML, FormatXMLExecuted, CheckCanExecuted));
        
            CommandBindings.Add(new CommandBinding(MyCommands.FormatXSD, FormatXSDExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.FormatXMLXSD, FormatXMLXSDExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.Wordwrap, WordwrapExecuted, CheckCanExecuted));

            CommandBindings.Add(new CommandBinding(MyCommands.StandardProfi, StandardProfiwrapExecuted, CheckCanExecuted));


            CommandBindings.Add(new CommandBinding(MyCommands.Optionen, OptionenExecuted, CheckCanExecuted));
            CommandBindings.Add(new CommandBinding(MyCommands.ProgInfo, ProgInfoExecuted, CheckCanExecuted));            

            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            // dispatcherTimer.Interval = new TimeSpan(0, 0, 1);  // hour, min, sec, ms
            dispatcherTimer.Interval = TimeSpan.FromMilliseconds(250);


            readFilelist();

            dispatcherTimer.Start();



            fontsize = 14;
            int fs;
            fs = Basis.ReadRegInt(SingVar.C_REG_ADR, "fontsize");
            if (fs > 0)
                setFontsizeRegistry(fs);
            else
                setFontsizeRegistry(fontsize);
            setColors();
        }  // window_Loaded


        private void setFontsize(int size) {
            this.fontsize = size;
            editXML.setFontsize(size);
            editXSD.setFontsize(size);
            editError.setFontsize(size);
            if (filelistLeft != null) {
                filelistLeft.setFontsize(size);
            }
            toolbar1.FontSize = size;
            mainMenu.FontSize = size;
            mnRecentFiles.FontSize = size;
            foreach (MenuItem menu in mnRecentFiles.Items) {
                menu.FontSize = size;
            }
            saveFont2Registry();
        }

        private void Window_PreviewMouseWheel(Object sender, MouseWheelEventArgs e) {
            if (Keyboard.Modifiers.HasFlag(ModifierKeys.Control)) {
                //Title = e.Delta.ToString();
                e.Handled = true;
                if (e.Delta > 0) {
                    fontsize += 2;
                    if (fontsize > 58)
                        fontsize = 58;
                }
                else {
                    fontsize -= 2;
                    if (fontsize < 8)
                        fontsize = 8;
                }
                setFontsizeRegistry(fontsize);
            }
            
        }


        private void setFontsizeRegistry(int fs) {
            if (fs == 8) {
                mnFont8pg.IsChecked = true;
                clearFontMenues(mnFont8pg);
                setFontsize(8);
            }
            if (fs == 10) {
                mnFont10pg.IsChecked = true;
                clearFontMenues(mnFont10pg);
                setFontsize(10);
            }
            if (fs == 12) {
                mnFont12pg.IsChecked = true;
                clearFontMenues(mnFont12pg);
                setFontsize(12);
            }
            if (fs == 14) {
                mnFont14pg.IsChecked = true;
                clearFontMenues(mnFont14pg);
                setFontsize(14);
            }
            if (fs == 16) {
                mnFont16pg.IsChecked = true;
                clearFontMenues(mnFont16pg);
                setFontsize(16);
            }
            if (fs == 18) {
                mnFont18pg.IsChecked = true;
                clearFontMenues(mnFont18pg);
                setFontsize(18);
            }
            if (fs == 20) {
                mnFont20pg.IsChecked = true;
                clearFontMenues(mnFont20pg);
                setFontsize(20);
            }
            if (fs == 24) {
                mnFont24pg.IsChecked = true;
                clearFontMenues(mnFont24pg);
                setFontsize(24);
            }
            if (fs == 28) {
                mnFont28pg.IsChecked = true;
                clearFontMenues(mnFont28pg);
                setFontsize(28);
            }
            if (fs == 30) {
                mnFont30pg.IsChecked = true;
                clearFontMenues(mnFont30pg);
                setFontsize(30);
            }
            if (fs == 32) {
                mnFont32pg.IsChecked = true;
                clearFontMenues(mnFont32pg);
                setFontsize(32);
            }
            if (fs == 34) {
                mnFont34pg.IsChecked = true;
                clearFontMenues(mnFont34pg);
                setFontsize(34);
            }
            if (fs == 36) {
                mnFont36pg.IsChecked = true;
                clearFontMenues(mnFont36pg);
                setFontsize(36);
            }
            if (fs == 38) {
                mnFont38pg.IsChecked = true;
                clearFontMenues(mnFont38pg);
                setFontsize(38);
            }
            if (fs == 40) {
                mnFont40pg.IsChecked = true;
                clearFontMenues(mnFont40pg);
                setFontsize(40);
            }
            if (fs == 42) {
                mnFont42pg.IsChecked = true;
                clearFontMenues(mnFont42pg);
                setFontsize(42);
            }
            if (fs == 44) {
                mnFont44pg.IsChecked = true;
                clearFontMenues(mnFont44pg);
                setFontsize(44);
            }
            if (fs == 46) {
                mnFont46pg.IsChecked = true;
                clearFontMenues(mnFont46pg);
                setFontsize(46);
            }
            if (fs == 48) {
                mnFont48pg.IsChecked = true;
                clearFontMenues(mnFont48pg);
                setFontsize(48);
            }
            if (fs == 50) {
                mnFont50pg.IsChecked = true;
                clearFontMenues(mnFont50pg);
                setFontsize(50);
            }
        }




        private void dispatcherTimer_Tick(object sender, EventArgs e)  {            
            editXML.setLineNummer();
            editXSD.setLineNummer();

            CommandManager.InvalidateRequerySuggested();

            // listBox1.Items.MoveCurrentToLast();
            // listBox1.SelectedItem = listBox1.Items.CurrentItem;
            // listBox1.ScrollIntoView(listBox1.Items.CurrentItem);
        }



        private void CheckCanExecuted(object sender, CanExecuteRoutedEventArgs e) {
            e.CanExecute = true;
        }

        private void NewExecuted(object sender, ExecutedRoutedEventArgs e)  {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Filter =
               "XML Dateien (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
            saveFileDialog1.Title = "Neue Datei speichern unter";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xml";
            saveFileDialog1.InitialDirectory = modell.ActualDirectory;
            saveFileDialog1.RestoreDirectory = true;
            if (saveFileDialog1.ShowDialog() == true)  {
                // Verarbeitung        
                modell.checkFile1();
                modell.checkFile2();
                modell.FilenameXML = saveFileDialog1.FileName.ToString();
                modell.FilenameXSD = Basis.changeFilenameExt(modell.FilenameXML, "xsd");
                FReadRoot dialog = new FReadRoot(this);
                dialog.ShowDialog();
                if (dialog.Retcode) {
                    editXML.ClearUndo();
                    editXSD.ClearUndo(); 
                    String root = dialog.root;
                    String firstItem = dialog.firstItem;
                    modell.EditXMLText = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\r\n" +
                                    "<"+root+"  "+ // xsi:noNamespaceSchemaLocation=\"" +   Basis.getFilename(modell.FilenameXSD) + "\"" + "\r\n" +
                                    "xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">" + "\r\n" +
                                    "   <" + firstItem + ">abc</" + firstItem + ">  \r\n" +
                                    "</"+root+">";
                    modell.EditXSDText = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\r\n" +
                                    "<xsd:schema xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">" + "\r\n" + "\r\n" +
                                    "<xsd:element name=\""+root+"\">" + "\r\n" +
                                    "\r\n" +
                                    "<xsd:complexType>\r\n"+
                                    "  <xsd:sequence>\r\n"+
                                    "    <xsd:element name=\""+ firstItem+ "\" type=\"xsd:string\"/>\r\n" +
                                    "  </xsd:sequence>\r\n"+
                                    "</xsd:complexType>\r\n"+

                                    "</xsd:element>" + "\r\n" +
                                    "\r\n" +
                                    "</xsd:schema>";

                    modell.saveAllFile(true, true);  // jetzt erst speichern
                    modell.notifyObservers();   // modify wird auf true gesetzt
                }
            }
        }  // mnNew_Click

        public MenuItem createMenuItem(MenuItem parent, String filename) {
            MenuItem mn = new MenuItem();            
            mn.Header = filename;
            mn.Click += new RoutedEventHandler(mnRecentFileList_Click);
            if (parent != null)
                parent.Items.Add(mn);
            mn.FontSize = this.fontsize;
            return mn;
        }


        private void readFilelist() {
            mnRecentFiles.Items.Clear();
            foreach (String filename in SingVar.fileliste) {
                createMenuItem(mnRecentFiles, filename);
            }
        }

        private void insertIntoFilelist(String filename) {
            foreach (String filenameLoop in SingVar.fileliste) {
                if (filenameLoop.ToLower().Equals(filename.ToLower())) {
                    return;
                }
            }
            createMenuItem(mnRecentFiles, filename);
        }

        //List<String> fileliste = new List<string>();

        private void mnClearRegistryOldFiles_Click(object sender, RoutedEventArgs e) {
            SingVar.fileliste.Clear();
        }



        void mnRecentFileList_Click(object sender, RoutedEventArgs e) {
            MenuItem mn = (MenuItem)e.Source;
            String filename = mn.Header.ToString();
            if (File.Exists(filename)) {
                modell.FilenameXML = filename;
                modell.notifyObservers();
                filelistLeft.setPath();
            }
            e.Handled = true;  // end of the Routings, else  three times !!



        }  // mnClick


        private void OpenExecuted(object sender, ExecutedRoutedEventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "XML-Dateien (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".xml";
            openFileDialog1.InitialDirectory = modell.ActualDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == true)  {
                modell.FilenameXML = openFileDialog1.FileName.ToString();
                modell.notifyObservers();
                //Basis.ErrorMsg("111", openFileDialog1.FileName.ToString());
                insertIntoFilelist(openFileDialog1.FileName.ToString());
            }
        }
        private void BnOpenXSD_Click(object sender, RoutedEventArgs e)  {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "XSD-Dateien (*.xsd)|*.xsd|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".xsd";
            openFileDialog1.InitialDirectory = modell.ActualDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == true)  {
                string sFilename = openFileDialog1.FileName.ToString();
                modell.FilenameXSD = sFilename;
                editXSD.loadFile();
            }
        }  // bnOpen2_Click

        private void BnOpenDTD_Click(object sender, RoutedEventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();
            openFileDialog1.Filter = "DTD-Dateien (*.dtd)|*.dtd|Alle Dateien (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;// zählt von 1 !
            openFileDialog1.DefaultExt = ".dtd";
            openFileDialog1.InitialDirectory = modell.ActualDirectory;
            openFileDialog1.Multiselect = false;
            openFileDialog1.RestoreDirectory = true;
            if (openFileDialog1.ShowDialog() == true) {
                string sFilename = openFileDialog1.FileName.ToString();
                modell.FilenameXSD = sFilename;
                editXSD.loadFile();
            }
        }  // bnOpen2_Click

        private void SaveExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (modell.FilenameXML.Equals("")) return;
            modell.saveAllFile(true, true);
        }

        private void SaveAsExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (modell.FilenameXML.Equals("")) return;
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.Title = "Speichern unter";
            saveFileDialog1.Filter =
               "XML Dateien (*.xml)|*.xml|Alle Dateien (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;// zählt von 1 !
            saveFileDialog1.DefaultExt = ".xml";
            saveFileDialog1.InitialDirectory = modell.ActualDirectory;
            saveFileDialog1.RestoreDirectory = true;
            saveFileDialog1.FileName = modell.FilenameXML;
            if (saveFileDialog1.ShowDialog() == true) {
                // Verarbeitung        
                String sFilenameXML = saveFileDialog1.FileName.ToString();
                String sXML = editXML.Text;  // für den Verweis auf die XSD bzw. DTD
                String sFilenameXSD_Old = modell.FilenameXSD;
                modell.FilenameXML = sFilenameXML;   // hier ist der neue Name, Update-Problem   XSD-Dateiname wird geloescht, da noch nicht vorhanden

                if (File.Exists(sFilenameXSD_Old)) {                    
                    String sFilenameXSD = "";
                    String sExt = Basis.getFilenameExt(sFilenameXSD_Old).ToLower();
                    if (sExt.Equals("dtd")) {
                        sFilenameXSD = Basis.changeFilenameExt(sFilenameXML, "dtd");
                        modell.FilenameXSD = sFilenameXSD;  // muss sein, weil sonst auf Leerstring gesetzt
                        String sXSD_Old = Basis.getFilename(sFilenameXSD);
                        sXML = sXML.Replace(sFilenameXSD_Old, sXSD_Old);
                    }
                    else
                        if (sExt.Equals("xsd")) {
                            sFilenameXSD = Basis.changeFilenameExt(sFilenameXML, "xsd");
                            modell.FilenameXSD = sFilenameXSD;  // muss sein, weil sonst auf Leerstring gesetzt
                            String sXSD_Old = Basis.getFilename(sFilenameXSD);
                            sXML = sXML.Replace(sFilenameXSD_Old, sXSD_Old);
                        }
                        else {
                            Basis.ErrorMsg("Falsche Dateierweiterung in SavaAs: " + sExt, "Fehler");
                        }

                }
                editXML.Text = sXML;
                modell.saveAllFile(true, true);
                modell.notifyObservers();
            }
        }  // mnSaveAs_Click

        private void UndoExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (editXML.isActive()) editXML.undoClick();
            if (editXSD.isActive()) editXSD.undoClick();
        }
        private void RedoExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (editXML.isActive()) editXML.redoClick();
            if (editXSD.isActive()) editXSD.redoClick();
        }

        private void CopyExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (editXML.isActive()) editXML.Copy();
            if (editXSD.isActive()) editXSD.Copy();
            if (editError.isActive()) editError.Copy();
        }

        private void PasteExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (editXML.isActive()) editXML.Paste();
            if (editXSD.isActive()) editXSD.Paste();
            if (editError.isActive()) editError.Paste();
        }
        private void CutExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (editXML.isActive()) editXML.Cut();
            if (editXSD.isActive()) editXSD.Cut();
            if (editError.isActive()) editError.Cut();
        }

        private void SelectallExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (editXML.isActive()) editXML.SelectAll();
            if (editXSD.isActive()) editXSD.SelectAll();
            if (editError.isActive()) editError.SelectAll();
        }

        private void SearchExecuted(object sender, ExecutedRoutedEventArgs e)  {
            int nr = 0;
            if (editXML.isActive()) nr = 1;
            if (editXSD.isActive()) nr = 2; // focus ist beim Dialog weg
            FSearch dialog = new FSearch(this);
            dialog.ShowDialog();
            if (dialog.Result) {
                search = dialog.SearchString;
                ignoreCase = dialog.IgnoreCase;
                editXML.Search = search;
                editXSD.IgnoreCase = ignoreCase;  // wenn 
                switch (nr)  {
                    case 1: editXML.searchText(search, ignoreCase);
                        break;
                    case 2: editXSD.searchText(search, ignoreCase);
                        break;
                    default: MessageBox.Show("Es war kein Editor aktiviert\r\nBitte in einen Editor klicken", "Suchen",
                            MessageBoxButton.OK, MessageBoxImage.Exclamation);
                        break;
                }
            }
        }

        private void SearchAgainExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (editXML.isActive()) editXML.searchAgain();
            if (editXSD.isActive()) editXSD.searchAgain();
        }


        private void Editor2NotepadExecuted(object sender, ExecutedRoutedEventArgs e)   {       
            String xml = modell.EditXMLText;
            String xsd = modell.EditXSDText;

            String filename = Basis.getTempFile();
            File.WriteAllText(filename, xml + "\r\n\r\n\r\n\r\n" + xsd);


                Process Prog = new Process();
                Prog.StartInfo.FileName = "Notepad.exe";
                Prog.StartInfo.Arguments = filename;
                Prog.Start();

        }



        private void NewInstanzExecuted(object sender, ExecutedRoutedEventArgs e)  {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "XMLVerify.exe";
            Prog.StartInfo.Arguments = "";
            Prog.Start(); 

        }
        
        private void CloseExecuted(object sender, ExecutedRoutedEventArgs e) {
           Close();
       }

       private void FormatXMLExecuted(object sender, ExecutedRoutedEventArgs e) {
           CModell modell = CModell.getInstance();
           if (!modell.FilenameXML.Equals("") && checkXML())  {
               editError.Text = "";
               editXML.prettyPrintXML();
               //editXML.prettyPrintXSD();
           }
       }

       private void FormatXSDExecuted(object sender, ExecutedRoutedEventArgs e) {
           CModell modell = CModell.getInstance();
           if (!modell.FilenameXSD.Equals(""))   {
               String sExt = Basis.getFilenameExt(modell.FilenameXSD).ToLower();
               if (sExt.Equals("xsd"))   {
                   if (!checkXMLDTD())  {
                       editError.Text = "";
                       editXSD.prettyPrintXSD();
                   }
               }
           }
       }

        
        private void FormatXMLXSDExecuted(object sender, ExecutedRoutedEventArgs e) {
            FormatXMLExecuted(sender, e);
            FormatXSDExecuted(sender, e);
        }

        private void WordwrapExecuted(object sender, ExecutedRoutedEventArgs e) {
           SingVar singvar = SingVar.getInstance();
           mnWordWrap.IsChecked = !mnWordWrap.IsChecked;
           singvar.WordWrap = mnWordWrap.IsChecked;
           editXML.WordWrap = editXSD.WordWrap = singvar.WordWrap;
       }

        private void StandardProfiwrapExecuted(object sender, ExecutedRoutedEventArgs e) {
            ColumnDefinitionCollection cols = splitContainer1.ColumnDefinitions;
            GridLength gl1;
            if (mnProfi.IsChecked)  {
                gl1 = new GridLength(0);
                BnStandard.Content = "Standard";                
            }
            else  {
                gl1 = new GridLength(200);
                BnStandard.Content = "Profi";                
            }
            cols[0].Width = gl1;
            mnProfi.IsChecked = !mnProfi.IsChecked;
        }


        private void OptionenExecuted(object sender, ExecutedRoutedEventArgs e)  {
            FOptionen dialog = new FOptionen(this);
            dialog.ShowDialog();

            if (dialog.Result)  {
                SingVar singvar = SingVar.getInstance();
                editXML.WordWrap = singvar.WordWrap;
                editXSD.WordWrap = singvar.WordWrap;
                //editXML.SetTabWidth(singvar.TabLength);
                //editXSD.SetTabWidth(singvar.TabLength);
                mnWordWrap.IsChecked = singvar.WordWrap;
                setColors();
            }
        }

        public void setColors() {
            editXML.setColors();
            editXSD.setColors();
            editError.setColors();
            filelistLeft.setColors();

        }

        private void ProgInfoExecuted(object sender, ExecutedRoutedEventArgs e)  {
            FProgInfo dialog = new FProgInfo(this);
            dialog.ShowDialog();
        }


        // einzeln Check
        private void ValidationXMLExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (modell.FilenameXML.Length == 0) return;
            editError.Text = "";
            checkXML();
        }
        // einzeln Check
        private void ValidationXSDExecuted(object sender, ExecutedRoutedEventArgs e) {
            if (modell.FilenameXML.Length == 0) return;
            editError.Text = String.Empty;
            checkXSD();
        }

        private void ValidationExecuted(object sender, ExecutedRoutedEventArgs e)  {
            if (modell.FilenameXML.Length == 0) return;
            modell.saveAllFile(true, true);
            editError.Text = "Validationnumber: " + (++validationnumber)+"\r\n";
            String sExt = Basis.getFilenameExt(modell.FilenameXSD).ToLower();
            if (sExt.Equals("dtd"))  {
                checkXML();
                checkXMLDTD();
            }
            else  {
                if (checkXML() && mnProfi.IsChecked)  {
                    // tree.insertNodes();
                }
                checkXSD();
            }
        }

       


        // http://msdn.microsoft.com/de-de/library/vstudio/bb387037.aspx
        // http://msdn.microsoft.com/de-de/library/bb354954%28v=vs.90%29.aspx
        private Boolean checkXML()  {
            String sError = String.Empty;
            try   {
                XmlSchemaSet schemas = new XmlSchemaSet();
                schemas.Add("", XmlReader.Create(new StringReader(editXSD.Text)));
                //schemas.Add("", XmlReader.Create( sFilename2 ));


                // XDocument xdoc = XDocument.Load(sFilename1);
                XDocument xdoc = XDocument.Parse(editXML.Text);


                // ValidationEventHandler handler = new ValidationEventHandler(MyHandler);
                // xdoc.Validate(schemas, handler);

                bool errors = false;
                xdoc.Validate(schemas, (o, err) =>
                {
                    sError = err.Message;
                    errors = true;
                });
                if (errors)
                    sError += "\r\nFehler in der XML-Datei: "; //+ editDatei1.Text;
                else
                    sError += "\r\nXML-Datei ist valide: "; // +editDatei1.Text;

                editError.Text += sError;
                return true;
            }
            catch (XmlSchemaException e2) {
                sError = "Fehler in der XML- oder XSD-Datei";
                sError += "\r\nLineNumber = " + e2.LineNumber;
                sError += "\r\nLinePosition = " + e2.LinePosition;
                sError += "\r\nZeile XML: " + Basis.getLine(e2.LineNumber, editXML.Text);
                sError += "\r\nZeile XSD: " + Basis.getLine(e2.LineNumber, editXSD.Text);
                sError += "\r\nText: " + e2.Message;
                editError.Text += sError;
                return false;
            }
            catch (XmlException e3) {
                sError = "Fehler in der XML- oder XSD-Datei";
                sError += "\r\nLineNumber = " + e3.LineNumber;
                sError += "\r\nZeile XML: " + Basis.getLine(e3.LineNumber, editXML.Text);
                sError += "\r\nZeile XSD: " + Basis.getLine(e3.LineNumber, editXSD.Text);
                sError += "\r\nLinePosition = " + e3.LinePosition;
                sError += "\r\nText: " + e3.Message;
                editError.Text += sError;
                return false;
            }


        } // checkXML

        // Display any validation errors.
        private void ValidationCallBack(object sender, ValidationEventArgs e) {
            editError.Text= "\r\nFehler in der XML-DTD-Datei:\r\n"+ e.Message;
        }

        String errorDTD = "";
        private Boolean checkXMLDTD2() {
            String sError = String.Empty;
            XmlReaderSettings settings = new XmlReaderSettings();

            settings.ValidationType = ValidationType.DTD;
            settings.DtdProcessing = DtdProcessing.Parse;
            settings.ValidationEventHandler += new ValidationEventHandler(ValidationCallBack);
            errorDTD = "";
            
            //settings.XmlResolver = new MyResolver();
            bool errors = false;

            CModell modell = CModell.getInstance();
            using (XmlReader reader = XmlReader.Create(modell.FilenameXML, settings)) {
                // Parse the file. 
                try {
                    while (reader.Read()) ;
                    editError.Text = "\r\nXML-Datei ist valide: "; //  +editDatei1.Text;
                    return false;
                }
                catch (XmlException e3) {
                    sError = "Fehler in der XML- oder DTD-Datei";
                    sError += "\r\nLineNumber = " + e3.LineNumber;
                    sError += "\r\nZeile XML: " + Basis.getLine(e3.LineNumber, editXML.Text);
                    sError += "\r\nZeile DTD: " + Basis.getLine(e3.LineNumber, editXSD.Text);
                    sError += "\r\nLinePosition = " + e3.LinePosition;
                    sError += "\r\nText: " + e3.Message;
                    editError.Text += sError;
                    errors = true;
                }
                catch (XmlSchemaException e2) {
                    errors = true;
                    sError = "Fehler in der XML- oder DTD-Datei";
                    sError += "\r\nLineNumber = " + e2.LineNumber;
                    sError += "\r\nLinePosition = " + e2.LinePosition;
                    sError += "\r\nZeile XML: " + Basis.getLine(e2.LineNumber, editXML.Text);
                    sError += "\r\nZeile DTD: " + Basis.getLine(e2.LineNumber, editXSD.Text);
                    sError += "\r\nText: " + e2.Message;
                    editError.Text += sError;
                }
                if (errors)
                    sError += "\r\nFehler in der XML-DTD-Datei: "; //+ editDatei1.Text;
                else
                    sError += "\r\nXML-Datei ist valide: "; //  +editDatei1.Text;

                editError.Text += sError;                
            }
            return errors;
        } // checkXMLDTD


        private Boolean checkXMLDTD()     {
            String sError = String.Empty;
            XmlReaderSettings settings = new XmlReaderSettings();

            settings.ValidationType = ValidationType.DTD;
            settings.DtdProcessing = DtdProcessing.Parse;


            //settings.XmlResolver = new MyResolver();
            XElement rootElement;
            bool errors = false;

            CModell modell = CModell.getInstance();
            using (XmlReader reader = XmlReader.Create(modell.FilenameXML, settings))   {
                try    {
                    rootElement = XElement.Load(reader);
                }

                catch (XmlException e3)   {
                    sError = "Fehler in der XML- oder DTD-Datei";
                    sError += "\r\nLineNumber = " + e3.LineNumber;
                    sError += "\r\nZeile XML: " + Basis.getLine(e3.LineNumber, editXML.Text);
                    sError += "\r\nZeile DTD: " + Basis.getLine(e3.LineNumber, editXSD.Text);
                    sError += "\r\nLinePosition = " + e3.LinePosition;
                    sError += "\r\nText: " + e3.Message;
                    editError.Text += sError;
                    errors = true;
                }
                catch (XmlSchemaException e2)  {
                    errors = true;
                    sError = "Fehler in der XML- oder DTD-Datei";
                    sError += "\r\nLineNumber = " + e2.LineNumber;
                    sError += "\r\nLinePosition = " + e2.LinePosition;
                    sError += "\r\nZeile XML: " + Basis.getLine(e2.LineNumber, editXML.Text);
                    sError += "\r\nZeile DTD: " + Basis.getLine(e2.LineNumber, editXSD.Text);
                    sError += "\r\nText: " + e2.Message;
                    editError.Text += sError;
                }
                if (errors)
                    sError += "\r\nFehler in der XML-DTD-Datei: "; //+ editDatei1.Text;
                else
                    sError += "\r\nXML-Datei ist valide: "; //  +editDatei1.Text;

                editError.Text += sError;

            }
            return errors;



        } // checkXMLDTD



        private void checkXSD()  {
            String sError = String.Empty;
            try  {
                XmlSchemaSet schemas = new XmlSchemaSet();

                // XDocument xdoc = XDocument.Load(sFilename2);
                XDocument xdoc = XDocument.Parse(editXSD.Text);


                bool errors = false;
                xdoc.Validate(schemas, (o, err) =>
                {
                    sError = err.Message;
                    errors = true;
                });
                if (errors)
                    sError += "\r\n\r\nFehler in der XSD-Datei: "; // + editDatei2.Text;
                else
                    sError += "\r\n\r\nXSD-Datei ist valide: "; // +editDatei2.Text;
                editError.Text += sError;
            }
            catch (XmlSchemaException e2) {
                sError = "Fehler in der XSD-Datei";
                sError += "\r\nLineNumber = " + e2.LineNumber;
                sError += "\r\nLinePosition = " + e2.LinePosition;
                sError += "\r\nZeile XSD: " + Basis.getLine(e2.LineNumber, editXSD.Text);
                sError += "\r\nText: " + e2.Message;
                editError.Text += sError;
            }
            catch (XmlException e3)  {
                sError = "Fehler in der XSD-Datei";
                sError += "\r\nLineNumber = " + e3.LineNumber;
                sError += "\r\nLinePosition = " + e3.LinePosition;
                sError += "\r\nZeile XSD: " + Basis.getLine(e3.LineNumber, editXSD.Text);
                sError += "\r\nText: " + e3.Message;
                editError.Text += sError;
            }


        } // checkXSD

        private void Window_Closed(object sender, EventArgs e)  {
            SingVar singvar = SingVar.getInstance();
            OldFiles oldfiles = OldFiles.getInstance();
            singvar.Setting = true;
            singvar.Top = (int)Top;
            singvar.Left = (int)Left;
            singvar.Width = (int)Width;
            singvar.Height = (int)Height;

            CModell modell = CModell.getInstance();
            if (!modell.FilenameXML.Equals(""))  {
                oldfiles.saveOldFile(modell.FilenameXML);
            }
            oldfiles.saveOldFiles2Registry();

        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)  {
            modell = CModell.getInstance();
            if (modell.XMLModified || modell.XSDModified)  {
                MessageBoxResult res = Basis.readYesNoCancel("Sollen die Änderungen gespeichert werden?", "Programm beenden");
                switch (res)   {
                    case MessageBoxResult.Yes: modell.saveAllFile(true, true);
                        break;
                    case MessageBoxResult.No:
                        break;
                    case MessageBoxResult.Cancel: e.Cancel = true;
                        break;
                }
            }
            if (e.Cancel == false)  {
                // das Eintragen der aktuellen Dateien geschieht beim lokalen Schliessen
                OldFiles instance = OldFiles.getInstance();
                instance.saveOldFiles2Registry();
            }
            saveFont2Registry();
        } // Closing

        private void saveFont2Registry() {
            if (mnFont8pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 8);
            if (mnFont10pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 10);
            if (mnFont12pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 12);
            if (mnFont14pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 14);
            if (mnFont16pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 16);
            if (mnFont18pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 18);
            if (mnFont20pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 20);
            if (mnFont24pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 24);
            if (mnFont28pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 28);

            if (mnFont30pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 28);
            if (mnFont32pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 28);
            if (mnFont34pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 30);
            if (mnFont36pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 36);
            if (mnFont38pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 38);
            if (mnFont40pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 40);
            if (mnFont42pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 42);
            if (mnFont44pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 44);
            if (mnFont46pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 46);
            if (mnFont48pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 48);
            if (mnFont50pg.IsChecked == true) Basis.WriteRegInt(SingVar.C_REG_ADR, "fontsize", 50);
        }


        public void update()  {
            this.Title = "XML-Verifier: " + modell.FilenameXML;
        }

        private void clearFontMenues(object sender)  {
            mnFont8pg.IsChecked = false;
            mnFont10pg.IsChecked = false;
            mnFont12pg.IsChecked = false;
            mnFont14pg.IsChecked = false;
            mnFont16pg.IsChecked = false;
            mnFont18pg.IsChecked = false;
            mnFont20pg.IsChecked = false;
            mnFont24pg.IsChecked = false;
            mnFont28pg.IsChecked = false;
            mnFont30pg.IsChecked = false;
            mnFont32pg.IsChecked = false;
            mnFont34pg.IsChecked = false;
            mnFont36pg.IsChecked = false;
            mnFont38pg.IsChecked = false;
            mnFont40pg.IsChecked = false;
            mnFont42pg.IsChecked = false;
            mnFont44pg.IsChecked = false;
            mnFont46pg.IsChecked = false;
            mnFont48pg.IsChecked = false;
            mnFont50pg.IsChecked = false;
            MenuItem mnItem = (MenuItem)sender;
            mnItem.IsChecked = true;
        }

        private void mnFont_Click(object sender, RoutedEventArgs e)  {
            MenuItem mn = (MenuItem)sender;
            clearFontMenues(sender);
            setFontsize(Convert.ToInt32(mn.Tag));
        }

        private void mnDatatyp_Click(object sender, RoutedEventArgs e) {
            showHelp(1);
        }

        private void mnAnnotation_Click(object sender, RoutedEventArgs e) {
            showHelp(2);
        }


        private void mnConstraints_Anzahl_Click(object sender, RoutedEventArgs e) {
            showHelp(3);
        }

        private void mnConstraints_Wertebereich_Click(object sender, RoutedEventArgs e) {
            showHelp(4);
        }

        private void mnConstraints_StringLength_Click(object sender, RoutedEventArgs e) {
            showHelp(5);
        }

        private void mnConstraints_Enumeration_Click(object sender, RoutedEventArgs e) {
            showHelp(6);
        }

        private void mnConstraints_Pattern_Click(object sender, RoutedEventArgs e) {
            showHelp(7);
        }

        private void mnConstraints_whiteSpace_Click(object sender, RoutedEventArgs e) {
            showHelp(8);
        }

        private void mnConstraints_Decimal_Click(object sender, RoutedEventArgs e) {
            showHelp(9);
        }

        private void mn_SimpleType_Click(object sender, RoutedEventArgs e) {
            showHelp(10);
        }
        private void mn_ComplexType_Click(object sender, RoutedEventArgs e) {
            showHelp(11);
        }
        private void mnAttribute_Click(object sender, RoutedEventArgs e) {
            showHelp(13);
        }

        private void mn_Beispiele_Click(object sender, RoutedEventArgs e) {
            showHelp(12);
        }

        private void showHelp(int nr) {
            FShowHelp dialog = new FShowHelp(nr);
            dialog.Show();
        }

    }
}
