﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections;
using System.IO;
using System.Windows;


namespace XMLVerify
{
    class OldFiles
    {
        public static string C_OLDFILE_MARKER = "!§$%&/()=?";
        // instance muss nach C_REG_ADR kommen
        private static OldFiles instance = new OldFiles();

        public ArrayList oldfiles = new ArrayList();


        private OldFiles()
        {
            loadOldFiles();  // aus Registry Adresse
        }

        public static OldFiles getInstance()
        {
            return instance;
        }

        public void clearOldFiles()
        {
            oldfiles.Clear();
        }

        public int count_oldfiles
        {
            get { return oldfiles.Count; }
        }

        public string getOldfile(int i)
        {
            if (i >= 0 && i < oldfiles.Count)
                return (string)oldfiles[i];
            else
                return null;
        }

        public void saveOldFile(String sFilename)
        {
            oldfiles.Add(sFilename);
        }

        public void loadOldFiles()
        {
            oldfiles.Clear();
            int n = Basis.ReadRegInt(SingVar.C_REG_ADR + "\\Files", "COUNT_FILES");
            if (n >= 10) n = 15;
            for (int i = 0; i < n; i++)
            {
                string sFile = Basis.ReadRegString(SingVar.C_REG_ADR + "\\Files", "FILE_" + (i + 1).ToString());
                if (File.Exists(sFile))
                {
                    oldfiles.Add(sFile);
                }

            }
        }

        public void saveFileToOldFiles(string sFilename)
        {
            foreach (string file in oldfiles)
            {
                if (file.Equals(sFilename, StringComparison.InvariantCultureIgnoreCase))
                {
                    return;  // schon vorhanden
                }
            }
            oldfiles.Insert(0, sFilename);
        }  // saveFile

        public void deleteFileFromOldFiles(string sFilename)
        {
            foreach (string file in oldfiles)
            {
                if (file.Equals(sFilename, StringComparison.InvariantCultureIgnoreCase))
                {
                    oldfiles.Remove(sFilename);
                    return;
                }
            }
        }  // deleteFile

        public void saveOldFiles2Registry()
        {
            int n = oldfiles.Count;
            Basis.WriteRegInt(SingVar.C_REG_ADR + "\\Files", "COUNT_FILES", n);
            for (int i = 0; i < n; i++)
            {
                string sFile = (string)oldfiles[i];
                Basis.WriteRegString(SingVar.C_REG_ADR + "\\Files", "FILE_" + (i + 1).ToString(), sFile);
            }
        }


        /*
        public void createOldFilesMenuItems(ToolStripMenuItem MainFile)
        {
            createList_OldFiles(MainFile);
            int n = oldfiles.Count;
            for (int i = 0; i < n; i++)
            {
                string sFile = (string)oldfiles[i];
                string sItem = "";
                switch (i + 1)
                {
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 9:
                        sItem = "&" + (i + 1).ToString() + " " + sFile;
                        break;
                    case 10: sItem = "1&0 " + sFile;
                        break;
                    default: sItem = (i + 1).ToString() + " " + sFile;
                        break;
                }
                MyToolStripMenuItem mnItem = new MyToolStripMenuItem(sItem, sFile);
                mnItem.Name = "File" + (i + 1).ToString();
                mnItem.Size = new System.Drawing.Size(279, 22);
                mnItem.Tag = C_OLDFILE_MARKER;
                MainFile.DropDownItems.Add(mnItem);
                mnItem.Click += new System.EventHandler(MnOldFile_Click);
            }
            saveOldFiles2Registry();
        }


        private void MnOldFile_Click(object sender, EventArgs e)
        {
            MyToolStripMenuItem mnItem = (MyToolStripMenuItem)sender;
            CModell modell = CModell.getInstance();
            modell.checkFile1();
            modell.checkFile2();
            modell.FilenameXML = mnItem.Filename;
            modell.notifyObservers();
        }


        public static void createList_OldFiles(ToolStripMenuItem MainFile)
        {
            ToolStripItemCollection coll = MainFile.DropDownItems;
            // an ToolStripSeparator denken
            int i = 0;
            ArrayList liste = new ArrayList();
            foreach (ToolStripItem control in coll)
            {
                if (control.GetType().Name.Equals("MyToolStripMenuItem"))
                {
                    liste.Add(i);
                }
                i++;
            }
            for (i = liste.Count - 1; i >= 0; i--)
            {
                int j = (int)liste[i];
                coll.RemoveAt((int)liste[i]);
            }
        }


        public static void setMergeAction(ToolStripMenuItem MainFile)
        {
            MainFile.MergeAction = MergeAction.MatchOnly;
            MainFile.MergeIndex = 3;
            ToolStripMenuItem menu;
            // var eintrag1 = contextMenuStrip1.Items.Cast<ToolStripItem>().Where(m => m.Text == "Eintrag 1").FirstOrDefault();
            ToolStripItemCollection coll = MainFile.DropDownItems;
            // ToolStripSeparator
            foreach (ToolStripItem control in coll)
            {
                if (control.GetType().Name.Equals("ToolStripMenuItem"))
                {
                    menu = (ToolStripMenuItem)control;
                    menu.MergeAction = MergeAction.MatchOnly;
                    menu.MergeIndex = 3;
                    setMergeAction(menu);
                }
            }
        }
        */

    }
}
